﻿using System;
using System.Threading;
using System.Threading.Tasks;

class Program
{
    static Random ran = new Random();
    static void Main(string[] args)
    {
        // Wait on a single task with no timeout.
        Task taskA = Task.Factory.StartNew(() => Worker(10000));
        taskA.Wait();
        Console.WriteLine("Task A Finished.");


        // Wait on a single task with a timeout.
        Task taskB = Task.Factory.StartNew(() => Worker(2000000));
        taskB.Wait(2000); //Wait for 2 seconds. 

        if (taskB.IsCompleted)
            Console.WriteLine("Task B Finished.");
        else
            Console.WriteLine("Timed out with out Task B finishing.");


        Task<double> taskC = Task<double>.Factory.StartNew(() => Worker1());

        Console.WriteLine("TaskC finished = result is {0}.", taskC.Result);

        Console.ReadLine();
    }


    static void Worker(int waitTime)
    {
        Thread.Sleep(waitTime);
    }

    static double Worker1()
    {
        int i = ran.Next(1000000);
        Thread.SpinWait(i);
        return i;
    }

}
