﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PLINQQuery
{
    class Program
    {
            public static void Main()
            {
                IEnumerable<int> collection = Enumerable.Range(10, 10000);

                Console.WriteLine("Press a key to see Method 1 results");
                Console.ReadLine();

                //Method 1 - This uses a ForAll method and an empty deleagte method.
                var PQ1 = from num in collection.AsParallel()
                                    where num % 10 == 0
                                    select num;

                PQ1.ForAll((i) => DoWork(i));

                // Use a standard foreach loop and merge the results.
                foreach (int i in PQ1)
                {
                    Console.WriteLine(i);
                }

                Console.WriteLine("Press a key to see Method 2 results");
                Console.ReadLine();

                // Method 2 - Use a standard TOArray method to return the results.
                var PQ2 = (from num in collection.AsParallel()
                                      where num % 10 == 0
                                      select num).ToArray();

                // Use a standard foreach loop and merge the results.
                foreach (int i in PQ2)
                {
                    Console.WriteLine(i);
                }

                Console.WriteLine("Press a key to see Method 3 results");
                Console.ReadLine();

                // Method 3 - Use the LINQ stanard method format.
                var PQ3 = collection.AsParallel().Where(n => n % 10 == 0).Select(n => n);

                // Use a standard foreach loop and merge the results.
                foreach (int i in PQ3)
                {
                    Console.WriteLine(i);
                }

                //Wait before exiting.
                Console.ReadLine();
            }

            static void DoWork(int i) 
            {
            }
        }
}
